package okototentest;

import java.util.ArrayList;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author kosen
 */
public class KanaInformation {
    public static final int PositonRight = 0;
    public static final int PositonLeft = 1;
    public static final int PositonRightRight = 2;
    public static final int PositonLeftLeft = 3;
    public static final int PositonOther = 4;
    public static final String[] positionName = {"右","左","右の右","左の左"};
    private String mystring;
    private String colorType;
    private int position;
    private String positionText;
    
    public KanaInformation(String inputText) {
        this.mystring = inputText;
        
    }

    public KanaInformation(KanaElement data) {
        this.mystring = data.text;
        this.colorType = data.style;
        this.position = data.position;
        this.positionText = data.positionText;
    }
    public KanaElement toKanaElement(){
        KanaElement elem = new KanaElement();
        elem.position = this.position;
        elem.positionText = this.positionText;
        elem.style = this.colorType;
        elem.text = this.mystring;
        elem.targetLength = 1;
        return elem;
    }

    public void setColorType(String col) {
        this.colorType = col;
   }

    public void setPositon(int pos) {
        if(pos<4){
            this.position = pos;
            this.positionText = positionName[pos];
        }
    }
    
    public void setPositionName(String othername){
        this.position = PositonOther;
        this.positionText = othername;
    }

    public int getPosition() {
        return this.position;
    }
    
    public KanaElement toElement(ArrayList<OkotoPlace> list){
        KanaElement ke = new KanaElement();
        ke.position = this.position;
        ke.positionText = this.positionText;
        ke.style = this.colorType;
        ke.text = this.mystring;
        ke.targetLength =  list.size();
        
        return ke;
    }    
}
