/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.type.TypeReference;
import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import java.awt.Point;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;


/**
 *
 * @author kosen
 */
public class OkototenTextJSON extends OkototenText{
    

    public OkototenTextJSON(){
        super();
    }
    public OkototenTextJSON(TaggedTextParser parser,File datafile,String encode) throws IOException{
        super(parser,datafile,encode);
    }

    @Override
    public boolean openFile(File file,String encode) throws IOException {

        StringBuilder json = new StringBuilder();
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file),encode));
        String line;
        while((line = reader.readLine()) != null){
            json.append(line);
            json.append("\n");
        }
        reader.close();
                
        ObjectMapper mapper = new ObjectMapper();
        ArrayList<OkototenObject> list = mapper.readValue(json.toString(), new TypeReference<ArrayList<OkototenObject>>() {});
        ArrayList<String> nameList = new ArrayList<String>();
        HashMap<String,ArrayList<String>> textMap = new HashMap<String,ArrayList<String>>();
        
        for(OkototenObject obj:list){
            this.mojiSet.put(obj.place, obj.character);
            int waridata = 0;
            if(obj.warityu){
                waridata = waridata | OkototenText.MASK_WARITYU;
            }
            if(obj.warityu_kaigyo){
                waridata = waridata | OkototenText.MASK_KAIGYO;
            }
            if(waridata != 0){
                this.warityu.put(obj.place, waridata);
            }
            if(obj.memo != null){
                this.commentset.put(obj.place, obj.memo);
            } else {
                this.commentset.put(obj.place, "");
            }

            
            ArrayList<OkototenElement> elements = new ArrayList<OkototenElement>();
            if(obj.elements != null){
                for(OkototenElement elem:obj.elements){
                    elements.add(elem);
                };
            }
            this.setOkotoTenElements(obj.place, elements);

            ArrayList<GojuntenElement> gojun = new ArrayList<GojuntenElement>();
            if(obj.gojunelements != null){
                for(GojuntenElement elem:obj.gojunelements){
                    gojun.add(elem);
                };
            }
            this.setGojunTenElements(obj.place, gojun);
            
            ArrayList<KanaElement> kana = new ArrayList<KanaElement>();
            if(obj.kanaelements != null){
                for(KanaElement elem:obj.kanaelements){
                    kana.add(elem);
                };
            }
            this.setKanaElements(obj.place, kana);

            
            ArrayList<String> texts;
            if(nameList.contains(obj.linename)){
                texts = textMap.get(obj.linename);
            } else {
                texts = new ArrayList<String>();
                nameList.add(obj.linename);
            }
            texts.add(obj.character);
            textMap.put(obj.linename, texts);
        }
        
        this.names = nameList;
        this.maxRowCount = -1;
        for(String linename:nameList){
            StringBuilder sbuf = new StringBuilder();
            for(String str:textMap.get(linename)){
                sbuf.append(str);
            }
            this.text.add(sbuf.toString());
            if(this.maxRowCount < sbuf.length()){
                this.maxRowCount = sbuf.length();
            }
        }
        return true;
    }

    @Override
    public synchronized boolean saveFile(File file,String encode) throws IOException {
        ArrayList<OkototenObject> list = new ArrayList<OkototenObject>();
        for(OkotoPlace place : this.getMojiKeyset()){
                OkototenObject obj = new OkototenObject();
                obj.place = place;
                obj.character = this.getMojiSet().get(place);
                obj.linename = this.names.get(place.getLineNumber() - 1);
                obj.elements = this.getDataSet().get(place).toArray(new OkototenElement[0]);
                if(this.getGojuntenDataSet().get(place) == null){
                    obj.gojunelements = new GojuntenElement[0];
                } else {
                    obj.gojunelements = this.getGojuntenDataSet().get(place).toArray(new GojuntenElement[0]);
                }
                if(this.getKanaDataSet().get(place) == null){
                    obj.kanaelements = new KanaElement[0];
                } else {
                    obj.kanaelements = this.getKanaDataSet().get(place).toArray(new KanaElement[0]);
                }
                
                obj.warityu = (this.getWarityuMask(place) & OkototenText.MASK_WARITYU) != 0;
                obj.warityu_kaigyo = (this.getWarityuMask(place) & OkototenText.MASK_KAIGYO) != 0;
                
                if(this.getCommentDataSet().get(place) != null){
                    obj.memo =  this.getCommentDataSet().get(place);
                }
                list.add(obj);
        }
        
        boolean backup = false;
        File backupfile = new File("backup.tmp");
        if(file.exists()){
            backup = true;
            copyFile(file,backupfile);
        }
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(new FileOutputStream(file),encode));
        ObjectMapper mapper = new ObjectMapper();
        mapper.enable(SerializationFeature.INDENT_OUTPUT);
        String json = mapper.writeValueAsString(list);
        writer.println(json);
        writer.close();
        if(backup){
            if(file.length() != 0){
               backupfile.deleteOnExit(); 
            } else {
                copyFile(backupfile,new File(file.getPath()+"."+"backup"));
            }
        }
        return true;
    }
    
    private synchronized int copyFile(File src,File dist) throws IOException{
        BufferedInputStream reader = new BufferedInputStream(new FileInputStream(src));
        BufferedOutputStream writer = new BufferedOutputStream(new FileOutputStream(dist));
        int buf;
        int size = 0;
        while((buf = reader.read()) != -1){
            writer.write(buf);
            size++;
        }
        reader.close();
        writer.close();
        return size;
    } 
    
    /* This is the test constractor*/
    public static void main(String[] args){
        String path = "C:\\Users\\kosen\\Desktop\\国語研科研用データ\\尚書プレーンテキスト";
        File baseFile = new File(path + File.separator + "尚書巻1-3春_181029統計_format.txt");
        File newFile = new File(path + File.separator + "尚書巻1-3春_181029統計_format.json");
        
        try {
            OkototenTextJSON okototext = new OkototenTextJSON(new TaggedTextParser(),baseFile,"UTF-8");
            OkotoPlace place1 = okototext.getMojiKeyset().get(0);
            OkototenElement elem = new OkototenElement();
            elem.position = new Point(2,2);
            elem.style = "朱点";
            elem.mark = "・";
            OkototenElement elem2 = new OkototenElement();
            elem2.position = new Point(1,-2);
            elem2.style = "朱点";
            elem2.mark = "・";
            okototext.addOkotoTenElement(place1, elem);
            okototext.addOkotoTenElement(place1, elem2);
            okototext.saveFile(newFile,"UTF-8");
            for(int i=0;i<100;i++){
                OkotoPlace place = okototext.getMojiKeyset().get(i);
                if(okototext.getWarityuMask(place) != 0){
                    System.out.print(okototext.getMojiSet().get(place));
                    if((okototext.getWarityuMask(place) & OkototenText.MASK_KAIGYO) != 0){
                        System.out.println();
                    }
                }
                
            }
            System.out.println();
            System.out.println();
            
            
            OkototenTextJSON okototext2 = new OkototenTextJSON();
            okototext2.openFile(newFile,"UTF-8");
            for(int i=0;i<100;i++){
                OkotoPlace place = okototext2.getMojiKeyset().get(i);
                if(okototext2.getWarityuMask(place) != 0){
                    System.out.print(okototext2.getMojiSet().get(place));
                    if((okototext2.getWarityuMask(place) & OkototenText.MASK_KAIGYO) != 0){
                        System.out.println();
                    }
                }
                
            }
            
            for(OkotoPlace place : okototext2.getMojiKeyset()){
                System.out.println(okototext2.getMojiSet().get(place));
                System.out.println(okototext2.getDataSet().get(place));
                
                /*
                OkototenElement elem1 = new OkototenElement();
                elem1.position = new Point(2,2);
                elem1.style = "朱点";
                elem1.mark = "・";
                okototext.addOkotoTenElement(place, elem1);
                okototext.addOkotoTenElement(place, elem2);
                
                OkototenObject hoge = new OkototenObject();
                hoge.place = place;
                hoge.character = okototext.getMojiSet().get(place);
                hoge.elements = okototext.getDataSet().get(place).toArray(new OkototenElement[0]);
                ObjectMapper mapper = new ObjectMapper();
                mapper.enable(SerializationFeature.INDENT_OUTPUT);
                String json = mapper.writeValueAsString(hoge);
                System.out.println(json);
                
                OkototenObject hoge2 = mapper.readValue(json, OkototenObject.class);
                System.out.println(hoge2);
                */
            }
            
        } catch (IOException ex) {
            Logger.getLogger(OkototenTextJSON.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
    }

    public int getMaxRowCount() {
        return this.maxRowCount;
    }






        
    
}

@JsonIgnoreProperties(ignoreUnknown=true)
class OkototenObject {
    public OkotoPlace place;
    public String character;
    public String linename;
    public boolean warityu;
    public boolean warityu_kaigyo;
    public String memo;
    public OkototenElement[] elements;
    public GojuntenElement[] gojunelements;
    public KanaElement[] kanaelements;
    
    
    public OkototenObject(){};
    
    @JsonCreator
    private OkototenObject(@JsonProperty("place") OkotoPlace place, @JsonProperty("character") String name, @JsonProperty("linename") String linename, 
            @JsonProperty("warityu") boolean wari,@JsonProperty("warityu_kaigyo") boolean warikai,@JsonProperty("memo") String memo_i) {
        this.place = place;
        this.character = name;
        this.linename = linename;
        this.warityu = wari;
        this.warityu_kaigyo = warikai;
        this.memo = memo_i;
    }

}
