/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import utf16.UnicodeCharactor;

/**
 *
 * @author t-koji
 */
public class TaggedTextParser {
    private ArrayList<String> indexNames;
    private ArrayList<String> inputText;
    private int maxLength;
    
    private Pattern mixedPattern = Pattern.compile("〓\\[(M[0-9]+),(U\\+[0-9A-Fa-f]+)\\]");
    private Pattern morohasiPattern = Pattern.compile("〓\\[(M[0-9]+)\\]");
    private Pattern ucsPattern = Pattern.compile("〓\\[(U\\+[0-9A-Fa-f]+)\\]");

    public ArrayList<String> getIndexNames(){
        return this.indexNames;
    }
    
    public ArrayList<String> getInputText(){
        return this.inputText;
    }
          
    public int getMaxRow(){
        return this.maxLength;
    }

    /** テキストフォーマットに対応した読み込み機能 読み込み後、最大文字長を返す*/
    public int readFile(File inputFile,String encode) throws UnsupportedEncodingException, IOException{
        this.indexNames = new ArrayList<String>();
        this.inputText = new ArrayList<String>();
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile),encode));
        int Maxrow = 0;
        String Line;
        while((Line = reader.readLine()) != null){
            String data;
            if(Line.indexOf(":") != -1){
                String[] elems = Line.split(":");
                this.indexNames.add(elems[0]);
                //System.out.println(elems[0]);
                if(elems.length > 1){
                    data = elems[1];
                } else {
                    data = "";
                }
            } else {
                data = Line;
            }
            //タグ要素を削除
            //data = data.replaceAll("［", ""); 
            //data = data.replaceAll("］", ""); 
            //data = data.replaceAll("／", ""); 
            data = data.replaceAll("\\{", ""); 
            data = data.replaceAll("\\}", ""); 
            data = data.replaceAll("\\+b", ""); 
            data = data.replaceAll("\\+w", ""); 
            data = data.replaceAll("\\+r", ""); 
            data = data.replaceAll("\\$b", ""); 
            data = data.replaceAll("#a", ""); 
            
            //外字を見つけて処理する
            Matcher mc = mixedPattern.matcher(data);
            while(mc.find()){
                String unicode = mc.group(2);
                String unichar = UnicodeCharactor.decodeUnicode(unicode);
                StringBuilder buf = new StringBuilder(data);
                buf.replace(mc.start(), mc.end(), unichar);
                data = buf.toString();
//                System.out.println("UCS fined " + unicode);
            }
            mc = ucsPattern.matcher(data);
            while(mc.find()){
                String unicode = mc.group(1);
                String unichar = UnicodeCharactor.decodeUnicode(unicode);
                StringBuilder buf = new StringBuilder(data);
                buf.replace(mc.start(), mc.end(), unichar);
                data = buf.toString();
//                System.out.println("UCS fined " + unicode);
            }
            
            //最大文字数を取得
            if(data.length() > Maxrow){
                Maxrow = data.length();
            }
            inputText.add(data);
        }
        this.maxLength = Maxrow;
        return Maxrow;
    }    
}
