/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Component;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.AbstractCellEditor;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableCellRenderer;

/**
 *
 * @author t-koji
 */
public class ButtonCellRenderer extends AbstractCellEditor implements TableCellRenderer,TableCellEditor {
    private final JButton button;
    private ButtonCellClickable parent;

    public ButtonCellRenderer(final JTable table,final ButtonCellClickable p,final int buttonColumn) {
        this.parent = p;
        this.button = new JButton("削除");
        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                fireEditingStopped(); // これが重要
            }
        });
        table.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                Point point = e.getPoint();
                if (table.columnAtPoint(point) == buttonColumn) {
                    fireEditingStopped();
                    int row = table.rowAtPoint(point);
                    if (row >= 0) {
                        p.removeTableRow(row);
                    }
                }
            }
        });
    }

    public Component getTableCellRendererComponent(JTable table,
                                                   Object value,
                                                   boolean isSelected,
                                                   boolean hasFocus,
                                                   int row,
                                                   int column) {
        return button;
    }

    public Component getTableCellEditorComponent(JTable table,
                                                 Object value,
                                                 boolean isSelected,
                                                 int row,
                                                 int column) {
        return button;
    }

    public Object getCellEditorValue() {
        return button.getText();
    }

}