/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Point;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import okototentest.KanaElement;
import okototentest.KanaInformation;
import okototentest.OkotoPlace;
import okototentest.OkototenElement;

/**
 *
 * @author ktajima
 */
public class KanaInfomationView extends javax.swing.JDialog implements ButtonCellClickable{
    //開いている文字の情報
    private OkotoInputForm baseForm;
    private OkotoPlace openStringIndex;
    private DefaultTableModel tablemodel;
        
    /**
     * Creates new form KanaInfomationView
     */
    public KanaInfomationView(OkotoInputForm parent, OkotoPlace place) {
        super(parent, true);
        initComponents();
        this.baseForm = parent;
        this.openStringIndex = place;
        this.refleshTableModel();
        
    }
    public void refleshTableModel(){
        //モデルを作る
        String[] column = {"位置","体裁","仮名","複数文字","削除"};
        this.tablemodel = new DefaultTableModel(column,0);

        //付与されている仮名情報をすべて取り出す
        ArrayList<KanaElement> tableData = this.baseForm.getKanaDataAt(this.openStringIndex);
        if(tableData != null){
            for(KanaElement element:tableData){
                String[] entry = new String[5];
                entry[0] = element.positionText;
                entry[1] = element.style;
                entry[2] = element.text;
                entry[3] = Integer.toString(element.targetLength);
                entry[4] = "";
                this.tablemodel.addRow(entry);
            }
        }
        //テーブルに反映させる
        this.jTable1.setModel(this.tablemodel);
        
        ButtonCellRenderer renderer = new ButtonCellRenderer(this.jTable1,this,4);
        TableColumn btncolumn = this.jTable1.getColumnModel().getColumn(4);
        btncolumn.setCellEditor(renderer);
        btncolumn.setCellRenderer(renderer);
        
        this.jTable1.validate();
        this.repaint();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        jButton1.setText("仮名情報を追加");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("閉じる");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 376, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 205, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.setVisible(false);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        KanaInputDialog dialog = new KanaInputDialog(this.baseForm, true);
        dialog.setVisible(true);
        KanaInformation kanadata = dialog.getKanaInfo();
        if(kanadata != null){
            ArrayList<KanaElement> tableData = this.baseForm.getKanaDataAt(this.openStringIndex);
            tableData.add(kanadata.toKanaElement());
            this.baseForm.setKanaDataAt(this.openStringIndex,tableData);
            this.refleshTableModel();
        }
    }//GEN-LAST:event_jButton1ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables

    /**削除ボタンが押されたときに呼びだされる*/
    @Override
    public void removeTableRow(int row) {
        ArrayList<KanaElement> tableData = this.baseForm.getKanaDataAt(this.openStringIndex);
        if(tableData != null){
            KanaElement elem = tableData.get(row);
            if(elem.targetLength > 1){
                //ツールチップなども削除する
                this.baseForm.setKanaTipsAndColor(this.openStringIndex,elem.targetLength,false,null);
            }
            tableData.remove(row);
            this.baseForm.setKanaDataAt(this.openStringIndex,tableData);
        }
        refleshTableModel();
    }
}
