/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.JPanel;
import okototentest.GojuntenElement;
import okototentest.OkotoPlace;
import okototentest.OkototenText;

/**
 *
 * @author kosen
 */
public class ListMojiPanel extends JPanel {

    public static Font charFont;
    public static Font wariFont;
    public static Font appendFont;
    private final OkotoPlace place;
    private final String printChar;
    private int warityu;

    private final int sidebuff = 10;
    
    private Color panelBackGroundColor = Color.white;
    private Color panelCharColor = Color.black;
    
    private boolean PanelSelected;
    private boolean hasOkototenData;
    private boolean hasKanaData;
    
    private final ArrayList<GojuntenElement> gojunmarks = new ArrayList<GojuntenElement>();
    
    public ListMojiPanel(int size,OkotoPlace ps, String moji,int wari) {
        super();
        this.setSize(new Dimension(size+2*sidebuff, size));
        this.setPreferredSize(new Dimension(size+2*sidebuff, size));
        ListMojiPanel.charFont = main.bootstrap.CharFont.deriveFont(Font.PLAIN, size);
        ListMojiPanel.wariFont = main.bootstrap.CharFont.deriveFont(Font.PLAIN, (int)(size/1.5));
        this.place = ps;
        this.printChar = moji;
        this.warityu = wari;
        ListMojiPanel.appendFont = main.bootstrap.CharFont.deriveFont(Font.PLAIN, 10);
        this.hasKanaData = false;
    }
    
    public void setBGColorNomal(){
        if(hasOkototenData){
            if(this.hasKanaData){
                this.panelBackGroundColor = new Color(0xda,0x70,0xd6);
                this.panelCharColor = Color.black;
            } else {
                this.panelBackGroundColor = new Color(0xff,0xc0,0xcb);
                this.panelCharColor = Color.black;
            }
        } else {
            if(this.hasKanaData){
                this.panelBackGroundColor = new Color(0xaf,0xee,0xee);
                this.panelCharColor = Color.black;
            } else {
                this.panelBackGroundColor = Color.white;
                this.panelCharColor = Color.black;
            }
        }
    }
    
    public void setBGColorSelected(){
        this.panelBackGroundColor = new Color(0xf5,0xde,0xb3);
        this.panelCharColor = Color.black;
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        BufferedImage myImage = new BufferedImage(this.getPreferredSize().width, this.getPreferredSize().height, BufferedImage.TYPE_INT_RGB);

        Graphics2D g2 = myImage.createGraphics();
        //背景
        if(this.PanelSelected){
            this.setBGColorSelected();
        } else {
            this.setBGColorNomal();
        }
        g2.setColor(this.panelBackGroundColor);
        g2.fillRect(0, 0, this.getPreferredSize().width, this.getPreferredSize().height);
        //外枠
        g2.setColor(Color.gray);
        g2.fillRect(0, 0, 3, this.getPreferredSize().height);
        g2.fillRect(this.getPreferredSize().width-3, 0, this.getPreferredSize().width-3, this.getPreferredSize().height);
        //文字
        g2.setColor(panelCharColor);
        if((this.warityu & OkototenText.MASK_WARITYU) != 0){
            g2.setFont(wariFont);
            g2.drawString(this.printChar, sidebuff*2, this.getPreferredSize().height - sidebuff*2);
        } else {
            g2.setFont(charFont);
            g2.drawString(this.printChar, sidebuff, this.getPreferredSize().height - 5);
        }
        //割注の改行
        if((this.warityu & OkototenText.MASK_KAIGYO) != 0){
            g2.setColor(Color.cyan);
            g2.drawLine(0, this.getPreferredSize().height-sidebuff*2, this.getPreferredSize().width, this.getPreferredSize().height-sidebuff);
        }
        //語順点
        g2.setFont(appendFont);
        int c=1;
        for(GojuntenElement elem:this.gojunmarks){
            if(elem.style.equals("朱")){
                g2.setColor(Color.red);
            } else {
                g2.setColor(Color.black);
            }
            g2.drawString(elem.mark, 5, this.getPreferredSize().height - 5*c);
            c++;
        }
        
        g.drawImage(myImage, 0, 0, this);
    }

    boolean isSelected() {
        return this.PanelSelected;
    }

    void setSelected(boolean b) {
        this.PanelSelected = b;
    }

    OkotoPlace getPlace() {
        return this.place;
    }

    void setBGColorOkoto(boolean b) {
        this.hasOkototenData = b;
    }

    void setGojunMark(ArrayList<GojuntenElement> elements) {
        this.gojunmarks.clear();
        this.gojunmarks.addAll(elements);
    }

    void setKanaMark(boolean b) {
        this.hasKanaData = b;        
    }

}
