/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SpringLayout;
import okototentest.GojuntenElement;
import okototentest.KanaElement;
import okototentest.OkotoPlace;
import okototentest.OkototenTextJSON;
import okototentest.TaggedTextParser;

/**
 *
 * @author kosen
 */
public class MojiTablePanel extends JPanel {

    /**
     * 動作テスト用のサンプルコード
     */
    public static void sampleBoot() {
        String path = "C:\\Users\\kosen\\Desktop\\国語研科研用データ\\尚書プレーンテキスト";
        File baseFile = new File(path + File.separator + "尚書巻1-3春_181029統計_format.txt");
//        File newFile = new File(path + File.separator + "尚書巻1-3春_171108_format.json");

        try {
            OkototenTextJSON okototext = new OkototenTextJSON(new TaggedTextParser(), baseFile, "UTF-8");

            JFrame frame = new JFrame();
            frame.setPreferredSize(new Dimension(640, 480));

//            
            MojiTablePanel mainpanel = new MojiTablePanel(okototext);
//            mainpanel.setFrame(frame);
            System.out.println(mainpanel.getPreferredSize());
            JScrollPane scp = new JScrollPane(mainpanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
//
            frame.getContentPane().add(scp);
            frame.pack();
            frame.setVisible(true);
            frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        } catch (IOException ex) {
            Logger.getLogger(OkototenTextJSON.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private final ArrayList<ListMojiPanel> selectedPanel = new ArrayList<ListMojiPanel>();
    private final HashMap<OkotoPlace, ListMojiPanel> panelSet = new HashMap<OkotoPlace, ListMojiPanel>();

    private OkotoInputForm pframe;

    public void setFrame(OkotoInputForm p) {
        this.pframe = p;
    }

    public MojiTablePanel(OkototenTextJSON data) {
        OkotoPlace end = data.getMojiKeyset().get(data.getMojiKeyset().size() - 1);

        //this.applyComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
        SpringLayout layout = new SpringLayout();
        this.setLayout(layout);

        JPanel lastone = null;
        int kanaMarkCount = 0;
        String kanaString = "";
        
        for (int i = 0; i < end.getLineNumber(); i++) {
            JPanel linePanel = new JPanel();
            linePanel.setLayout(new BoxLayout(linePanel, BoxLayout.Y_AXIS));
            final String name = data.getIndexNames().get(i);
            //巻１：１オ01
            String maki = name.substring(0, name.indexOf("："));
            String page = name.substring(name.indexOf("：") + 1, name.length() - 2);
            linePanel.add(new JLabel(maki));
            linePanel.add(new JLabel(page));

            JButton button = new JButton(name.substring(name.length() - 2));
            button.setToolTipText(name);
            button.addActionListener(new ActionListener() {
                @Override
                public void actionPerformed(ActionEvent ae) {
                    JOptionPane.showMessageDialog(pframe, name);
                }
            });
            button.setPreferredSize(new Dimension(40, 30));
            button.setMinimumSize(new Dimension(40, 30));
            linePanel.add(button);
            for (int j = 0; j < data.getMaxRowCount(); j++) {
                OkotoPlace cur = new OkotoPlace(i + 1, j + 1);
                if (data.getMojiSet().containsKey(cur)) {
                    int wari = data.getWarityuMask(cur);
                    final ListMojiPanel mojipanel = new ListMojiPanel(50, cur, data.getMojiSet().get(cur), wari);
                    this.panelSet.put(cur, mojipanel);
                    if(data.getDataSet().containsKey(cur)){
                        if(!data.getDataSet().get(cur).isEmpty()){
                            mojipanel.setBGColorOkoto(true);
                        }
                    }
                    if(data.getGojuntenDataSet().containsKey(cur)){
                        if(!data.getGojuntenDataSet().get(cur).isEmpty()){
                            mojipanel.setGojunMark(data.getGojuntenDataSet().get(cur));
                        }
                    }
                    
                    mojipanel.addMouseListener(new MouseAdapter() {
                        @Override
                        public void mouseReleased(MouseEvent e) {
                            if(e.getButton() == MouseEvent.BUTTON3){
                                //右クリックした
                                for (ListMojiPanel panel : selectedPanel) {
                                    panel.setSelected(false);
                                }
                                selectedPanel.clear();
                                mojipanel.setSelected(true);
                                selectedPanel.add(mojipanel);
                                MojiTablePanel.this.panelSelected(mojipanel,e);
                            } else if ((e.getModifiersEx() & MouseEvent.CTRL_DOWN_MASK) == MouseEvent.CTRL_DOWN_MASK) {
                                if (mojipanel.isSelected()) {
                                    mojipanel.setSelected(false);
                                    selectedPanel.remove(mojipanel);
                                } else {
                                    mojipanel.setSelected(true);
                                    selectedPanel.add(mojipanel);
                                }
                            } else if (mojipanel.isSelected()) {
                                //CTRLで複数選んだあと、その文字をクリックした
                                MojiTablePanel.this.panelSelected(mojipanel,e);
                            } else {
                                //選択されていない文字を新たにクリックした
                                for (ListMojiPanel panel : selectedPanel) {
                                    panel.setSelected(false);
                                }
                                selectedPanel.clear();
                                mojipanel.setSelected(true);
                                selectedPanel.add(mojipanel);
                                MojiTablePanel.this.panelSelected(mojipanel,e);
                            }
                            MojiTablePanel.this.validate();
                            MojiTablePanel.this.repaint();
                            return;
                        }
                    });
                    
                    ArrayList<KanaElement> klist = data.getKanaDataSet().get(cur);
                    if(klist != null){
                        for(KanaElement elem:klist){
                            if(elem.targetLength > 1){
                                kanaMarkCount = elem.targetLength;
                                kanaString = elem.text;
                            }
                        }
                    }
                    if(kanaMarkCount > 0){
                            mojipanel.setToolTipText("<html><span style=\"font-size: 180%;\">"+kanaString+"</span></html>");
                            mojipanel.setKanaMark(true);
                            kanaMarkCount--;

                    }
                    linePanel.add(mojipanel);
                }
            }
            if (i == 0) {
                layout.putConstraint(SpringLayout.EAST, linePanel, 0, SpringLayout.EAST, this);
                layout.putConstraint(SpringLayout.NORTH, linePanel, 0, SpringLayout.NORTH, this);
                this.add(linePanel);
            } else {
                layout.putConstraint(SpringLayout.EAST, linePanel, 0, SpringLayout.WEST, lastone);
                layout.putConstraint(SpringLayout.NORTH, linePanel, 0, SpringLayout.NORTH, this);
                this.add(linePanel);
            }
            lastone = linePanel;
        }
        layout.putConstraint(SpringLayout.WEST, this, 0, SpringLayout.EAST, lastone);

        this.setPreferredSize(new Dimension(end.getLineNumber() * (int) lastone.getPreferredSize().getWidth(), data.getMaxRowCount() * (int) lastone.getPreferredSize().getWidth()));
    }

    /**
     * パネルクリック時の処理
     */
    private void panelSelected(ListMojiPanel mojipanel,MouseEvent e) {
        this.pframe.cellSelected(mojipanel,e);
    }

    public int getSelectedCount() {
        return selectedPanel.size();
    }

    public ArrayList<ListMojiPanel> getSelectedPanel() {
        return this.selectedPanel;
    }

    /**
     * ヲコト点が付与されているかの情報を追加する
     */
    void setFillwithOkoto(OkotoPlace place, boolean b) {
        ListMojiPanel panel = this.selectedPanel.get(0);
        if (panel.getPlace().equals(place)) {
            panel.setBGColorOkoto(b);
        }
    }

    void setSelectedPanel(OkotoPlace newplace) {
        for (ListMojiPanel panel : selectedPanel) {
            panel.setSelected(false);
        }
        selectedPanel.clear();
        ListMojiPanel mojipanel = this.panelSet.get(newplace);
        mojipanel.setSelected(true);
        selectedPanel.add(mojipanel);
        this.validate();
        this.repaint();
    }

    void setGojunMark(OkotoPlace place,ArrayList<GojuntenElement> elems) {
        ListMojiPanel mojipanel = this.panelSet.get(place);
        mojipanel.setGojunMark(elems);
        this.validate();
        this.repaint();
    }
    
    public ListMojiPanel getPanel(OkotoPlace place){
        return this.panelSet.get(place);
    }
    




}
