/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import okototentest.KanaInformation;
import java.awt.*;
import java.awt.datatransfer.StringSelection;
import java.awt.event.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import okototentest.GojuntenElement;
import okototentest.KanaElement;
import okototentest.OkotoKigouSet;
import okototentest.OkotoPlace;
import okototentest.OkototenElement;

/**
 *
 * @author t-koji
 */
public class OkotoInputDialog extends javax.swing.JDialog implements ButtonCellClickable{
    public static final Pattern PointPattern = Pattern.compile("\\(([-0-9]+),([-0-9]+)\\)");
    public static final int BUTTONFONTSIZE = 20;

    private static String defualtKigou = "";
    private static int defualtSelectedPenID = -1;

    private JButton[] buttons;
    private HashMap<Point, Integer> buttonMap;
    private int gridSize = 7;
    private CharprintedPanel ClickablePanel;
    private String SelectedKigou = "";
    private int selectedPenID;

    //ペンの種類
    private int penSize;
    private ArrayList<Color> penColor;
    private ArrayList<String> penName;
    private ArrayList<Color> penNameColor;

    //開いている文字の情報
    private OkotoInputForm baseForm;
    private OkotoPlace openStringIndex;

    //選択した情報
    DefaultTableModel tablemodel;
    ArrayList<OkototenElement> okotoTenData;
    ArrayList<GojuntenElement> gojuntenData;
    
    

    /**
     * Creates new form OkotoInputDialog
     */
    public OkotoInputDialog(OkotoInputForm parent, boolean modal) {
        super(parent, modal);
        this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

        initComponents();
        if (defualtSelectedPenID != -1) {
            this.selectedPenID = defualtSelectedPenID;
        }
        if (!defualtKigou.equals("")) {
            this.SelectedKigou = defualtKigou;
        }
        this.addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                OkotoInputDialog.this.windowClosing();
            }
        });
        this.baseForm = parent;
        this.ClickablePanel = new CharprintedPanel();
        this.ClickablePanel.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                if (e.getButton() == MouseEvent.BUTTON1) {
                    Point p = OkotoInputDialog.this.ClickablePanel.getClickedLocation(e.getPoint());
                    OkotoInputDialog.this.ImageClicked(p);
                } else {
                    OkotoInputDialog.this.formMouseClicked(e);
                }
            }
        });
        this.ClickablePanel.setPreferredSize(new Dimension(274, 274));
        this.jPanel1.setLayout(new GridLayout(1, 1));
        this.jPanel1.add(this.ClickablePanel);

        //元データ呼び出し
        String EditString = this.baseForm.getSelectedString();
        this.ClickablePanel.setImageChar(EditString);

        if (this.baseForm.getSelectedIndex() == null) {
            JOptionPane.showMessageDialog(this, "複数の文字を選んでいるのにタグ編集を行おうとしています。", "文字選択Error", JOptionPane.ERROR_MESSAGE);
            this.openStringIndex = new OkotoPlace(1, 1);
        } else {
            this.openStringIndex = this.baseForm.getSelectedIndex();
        }
        this.jLabel3.setText(this.baseForm.getCurrentLineTitle() + "(" + this.openStringIndex.x + "行目)," + this.openStringIndex.y + "文字目の入力処理");
        this.setTitle(this.baseForm.getCurrentLineTitle() + "(" + this.openStringIndex.x + "行目)," + this.openStringIndex.y + "文字目の入力処理");
        this.jPanel1.validate();

        this.refleshKigouTable();
        this.setDefalutPenSet();
        this.refleshPenSelectTable();

        //データテーブルの初期化
        this.okotoTenData = new ArrayList<OkototenElement>();
        this.gojuntenData = new ArrayList<GojuntenElement>();
        String[] column = {"位置", "体裁", "記号", "削除"};
        this.tablemodel = new DefaultTableModel(column, 0);
        
        //もともとのデータがあれば追加
        ArrayList<OkototenElement> tableData = this.baseForm.getDataAt(this.openStringIndex);
        //ArrayList<String[]> tableData = this.baseForm.getDataAt(this.openStringIndex);
        if (tableData != null) {
            this.okotoTenData.addAll(tableData);
            for (OkototenElement elements : this.okotoTenData) {
                String[] entry = new String[4];
                entry[0] = "(" + elements.position.x + "," + elements.position.y + ")";
                entry[1] = elements.style;
                entry[2] = elements.mark;
                entry[3] = "";
                this.tablemodel.addRow(entry);

                this.ClickablePanel.addFillCell(elements.position, elements.style);

            }
        }

        
        //語順点関係のBOXリスト
        JCheckBox[] cboxs = {this.jCheckBox1,this.jCheckBox2,this.jCheckBox3,this.jCheckBox4,this.jCheckBox5,this.jCheckBox6,this.jCheckBox7,this.jCheckBox8,this.jCheckBox9};
        checkboxloading = true;
        //もともとのデータがあれば追加
        ArrayList<GojuntenElement> gojunData = this.baseForm.getGojunDataAt(this.openStringIndex);
        if (gojunData != null) {
            this.gojuntenData.addAll(gojunData);
            for(GojuntenElement elements : this.gojuntenData) {
                String[] entry = new String[4];
                entry[0] = "語順点";
                entry[1] = elements.style;
                entry[2] = elements.mark;
                entry[3] = "";
                this.tablemodel.addRow(entry);
                for(JCheckBox cbox:cboxs){
                    if(cbox.getText().equals(elements.mark)){
                        cbox.setSelected(true);
                    }
                }
            }
            
        }
        checkboxloading = false;
        this.jTable1.setModel(this.tablemodel);

        ButtonCellRenderer renderer = new ButtonCellRenderer(this.jTable1, this, 3);
        TableColumn btncolumn = this.jTable1.getColumnModel().getColumn(3);
        btncolumn.setCellEditor(renderer);
        btncolumn.setCellRenderer(renderer);

        
        this.buttonMap = new HashMap<Point, Integer>();
        
        
        //仮名点関係の読み込み
        this.setRightText("仮名情報を入力",Color.BLACK);
        this.setLeftText("仮名情報を入力",Color.RED);
        //もともとのデータがあれば追加
        loadKanaData();
        
        //もともとのデータがあればコメントを追加
        this.jTextArea1.setText(this.baseForm.getCommentAt(this.openStringIndex));
        
        this.pack();
        this.validate();
        this.repaint();

    }

    private void loadKanaData(){
        //this.kanaData = new HashMap<Integer, KanaInformation>();
        ArrayList<KanaElement> kanaData = this.baseForm.getKanaDataAt(this.openStringIndex);
        if (kanaData != null) {
            for(KanaElement elem:kanaData){
                if(elem.targetLength == 1){
                    if(elem.position == KanaInformation.PositonRight){
                        Color pencolor = Color.black;
                        int index = this.penName.indexOf(elem.style);
                        if(index != -1){
                            pencolor = this.penColor.get(index);
                        }
                        this.setRightText(elem.text, pencolor);
                    } else if(elem.position == KanaInformation.PositonLeft){
                        Color pencolor = Color.black;
                        int index = this.penName.indexOf(elem.style);
                        if(index != -1){
                            pencolor = this.penColor.get(index);
                        }
                        this.setLeftText(elem.text, pencolor);
                    }
                }
            }
        }
        
    }
    
    private void setRightText(String text,Color color) {
        String red = Integer.toHexString(color.getRed());
        if(red.length() < 2) red = "0"+red;
        String green = Integer.toHexString(color.getGreen());
        if(green.length() < 2) green = "0"+green;
        String blue = Integer.toHexString(color.getBlue());
        if(blue.length() < 2) blue = "0"+blue;
        String hexcolor = red+green+blue;
        StringBuilder sbuf = new StringBuilder();
        sbuf.append("<html><span style=\"-ms-writing-mode: tb-rl;writing-mode: vertical-rl; color: #"+hexcolor+";\">");
        for (int i = 0; i < text.length(); i++) {
            String c = text.substring(i, i + 1);
            sbuf.append(c);
            sbuf.append("<br>");
        }
        sbuf.append("</html>");
        this.jLabel6.setText(sbuf.toString());
        this.jLabel6.setOpaque(true);
        if(color.equals(Color.white)){
            this.jLabel6.setBackground(Color.black);
        } else {
            this.jLabel6.setBackground(Color.white);
        }
    }

    private void setLeftText(String text,Color color) {
        String red = Integer.toHexString(color.getRed());
        if(red.length() < 2) red = "0"+red;
        String green = Integer.toHexString(color.getGreen());
        if(green.length() < 2) green = "0"+green;
        String blue = Integer.toHexString(color.getBlue());
        if(blue.length() < 2) blue = "0"+blue;
        String hexcolor = red+green+blue;
        StringBuilder sbuf = new StringBuilder();
        sbuf.append("<html><span style=\"-ms-writing-mode: tb-rl;writing-mode: vertical-rl; color: #"+hexcolor+";\">");
        for (int i = 0; i < text.length(); i++) {
            String c = text.substring(i, i + 1);
            sbuf.append(c);
            sbuf.append("<br>");
        }
        sbuf.append("</html>");
        this.jLabel7.setText(sbuf.toString());
        this.jLabel7.setOpaque(true);
        if(color.equals(Color.white)){
            this.jLabel7.setBackground(Color.black);
        } else {
            this.jLabel7.setBackground(Color.white);
        }
    }

    /**
     * 表に要素が追加されたとき
     */
    public void addOkototenDataToTable(String[] column, Point p) {
        OkototenElement element = new OkototenElement();
        element.position = p;
        element.style = column[1];
        element.mark = column[2];
        this.okotoTenData.add(element);
        
        this.tablemodel.addRow(column);
        this.jTable1.setModel(this.tablemodel);
        this.jTable1.validate();

        this.ClickablePanel.addFillCell(element.position, element.style);
        this.repaint();
    }

    /**
     * 表に語順点を追加したとき
     */
    public void addGojunDataToTable(String[] column) {
        GojuntenElement element = new GojuntenElement();
        element.style = column[1];
        element.mark = column[2];
        this.gojuntenData.add(element);
        
        this.tablemodel.addRow(column);
        this.jTable1.setModel(this.tablemodel);
        this.jTable1.validate();
        this.repaint();
    }

    /**
     * 表の削除ボタンが押されたとき
     */
    public void removeTableRow(int row) {
        String type = (String)this.tablemodel.getValueAt(row, 0);
        if(type.equals("語順点")){
            GojuntenElement serchElement = new GojuntenElement();
            serchElement.style = (String)this.tablemodel.getValueAt(row, 1);
            serchElement.mark = (String)this.tablemodel.getValueAt(row, 2);
            int hit = -1;
            for(int i=0;i<this.gojuntenData.size();i++){
                if(serchElement.style.equals(this.gojuntenData.get(i).style) &&
                   serchElement.mark.equals(this.gojuntenData.get(i).mark) ){
                    hit = i;
                    break;
                }
            }
            if(hit != -1){
                this.gojuntenData.remove(hit);
                if(serchElement.mark.equals("レ")){
                    this.jCheckBox3.setSelected(false);
                }
                    
            }
        } else {
            OkototenElement serchElement = new OkototenElement();
            Matcher mc = PointPattern.matcher((String)this.tablemodel.getValueAt(row, 0));
            if(mc.matches()){
                serchElement.position = new Point(Integer.parseInt(mc.group(1)),Integer.parseInt(mc.group(2)));
            }
            serchElement.style = (String)this.tablemodel.getValueAt(row, 1);
            serchElement.mark = (String)this.tablemodel.getValueAt(row, 2);
            
            int hit = -1;
            for(int i=0;i<this.okotoTenData.size();i++){
                if(this.okotoTenData.get(i).mark == null){
                    break;
                }
                if(serchElement.position.equals(this.okotoTenData.get(i).position) &&
                   serchElement.style.equals(this.okotoTenData.get(i).style) &&
                   serchElement.mark.equals(this.okotoTenData.get(i).mark) ){
                    hit = i;
                    break;
                }
            }
            if(hit != -1){
                Point position = this.okotoTenData.get(hit).position;
                this.ClickablePanel.removeFillCell(position);
                this.okotoTenData.remove(hit);
            }
        }
        this.tablemodel.removeRow(row);
        this.jTable1.setModel(this.tablemodel);
        this.jTable1.validate();
        this.repaint();
    }

    public void removeGojunDataFromTable(String[] col) {
        int row = -1;
        for(int i=0;i<this.tablemodel.getRowCount();i++){
            String type = (String)this.tablemodel.getValueAt(i, 0);
            String style = (String)this.tablemodel.getValueAt(i, 1);
            String mark = (String)this.tablemodel.getValueAt(i, 2);
            if(type.equals("語順点") && style.equals(col[1]) && mark.equals(col[2])){
                row = i;
                break;
            }
        }
        
        if(row != -1){
            this.tablemodel.removeRow(row);
            this.jTable1.setModel(this.tablemodel);
            this.jTable1.validate();
            this.repaint();
        }
        
        int hit = -1;
        for(int i=0;i<this.gojuntenData.size();i++){
            if(col[1].equals(this.gojuntenData.get(i).style) &&
                col[2].equals(this.gojuntenData.get(i).mark) ){
                hit = i;
                break;
            }
        }
        if(hit != -1){
            this.gojuntenData.remove(hit);
        }
        
    }


            
            
    /**
     * 標準ペンセット
     */
    public void setDefalutPenSet() {
        this.penColor = new ArrayList<Color>();
        this.penName = new ArrayList<String>();
        this.penNameColor = new ArrayList<Color>();

        this.penColor.add(new Color(239, 69, 74));
        this.penName.add("朱");
        this.penNameColor.add(Color.black);

        this.penColor.add(Color.black);
        this.penName.add("墨");
        this.penNameColor.add(Color.white);

        this.penColor.add(Color.white);
        this.penName.add("白");
        this.penNameColor.add(Color.black);

        this.penColor.add(Color.green);
        this.penName.add("角");
        this.penNameColor.add(Color.black);

        this.penSize = this.penColor.size();
    }

    /**
     * 体裁が選択または追加されたときに再描画する
     */
    private void refleshPenSelectTable() {
        this.jPanel2.setLayout(new GridLayout(1, this.penSize));
        this.jPanel2.setPreferredSize(new Dimension(200, 50));
        this.jPanel2.removeAll();
        for (int i = 0; i < this.penSize; i++) {
            SelecTableLabel lb = new SelecTableLabel(this.penColor.get(i), i == this.selectedPenID);
            lb.setText(this.penName.get(i));
            lb.setForeground(this.penNameColor.get(i));
            lb.addMouseListener(new MouseAdapter() {
                @Override
                public void mouseClicked(MouseEvent e) {
                    if (e.getButton() == MouseEvent.BUTTON1) {
                        OkotoInputDialog.this.PenSelectClicked((SelecTableLabel) e.getSource());
                    } else {
                        OkotoInputDialog.this.formMouseClicked(e);
                    }
                }
            });
            lb.validate();
            this.jPanel2.add(lb);
        }
        this.jPanel2.validate();
    }

    /**
     * 筆の種類が選択されたときに呼び出される
     */
    private void PenSelectClicked(SelecTableLabel label) {
        label.setSelected(true);
        this.selectedPenID = this.penColor.indexOf(label.getColor());
        defualtSelectedPenID = this.penColor.indexOf(label.getColor());
        refleshPenSelectTable();
    }

    /**
     * 記号の種類が選択または追加されたときに再描画する
     */
    private void refleshKigouTable() {
        int columnCount = 5;
        String[] kigouList = OkotoKigouSet.getElements();
        int rowCount = kigouList.length / columnCount;
        if (kigouList.length % columnCount != 0) {
            rowCount++;
        }
        if (rowCount > 3) {
            rowCount = 3;
        }

        this.jPanel3.removeAll();
        this.jPanel3.setLayout(new GridLayout(rowCount, columnCount));
        boolean tempAdd = true;
        for (int i = 0; i < kigouList.length && i < 13; i++) {
            JButton kigouSelectButton = new JButton(kigouList[i]);
            if (kigouList[i].equals(this.SelectedKigou)) {
                kigouSelectButton.setBackground(SelecTableLabel.selectedColor);
                tempAdd = false;
            }
            kigouSelectButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    OkotoInputDialog.this.kigouButtonClicked((JButton) e.getSource());
                }
            });
            //ボタンの文字サイズを指定
            Font baseFont = main.bootstrap.ButtonFont.deriveFont(Font.PLAIN, BUTTONFONTSIZE);
            kigouSelectButton.setFont(baseFont);
            //

            this.jPanel3.add(kigouSelectButton);
        }
        //その他からボタンを選んだ場合
        if (tempAdd && !this.SelectedKigou.equals("")) {
            JButton kigouSelectButton = new JButton(this.SelectedKigou);
            kigouSelectButton.setBackground(SelecTableLabel.selectedColor);
            kigouSelectButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    OkotoInputDialog.this.kigouButtonClicked((JButton) e.getSource());
                }
            });
            Font baseFont = main.bootstrap.ButtonFont.deriveFont(Font.PLAIN, BUTTONFONTSIZE);
            kigouSelectButton.setFont(baseFont);
            this.jPanel3.add(kigouSelectButton);
        }
        JButton otherSelectButton = new JButton("その他");
        otherSelectButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                KigouSentakuDialog dialog = new KigouSentakuDialog(OkotoInputDialog.this.baseForm);
                dialog.setVisible(true);
                OkotoInputDialog.this.kigouButtonClicked(dialog.getSelectedKigou());
            }
        });
        this.jPanel3.add(otherSelectButton);
        this.jPanel3.validate();
    }

    /**
     * 記号選択ボタンがクリックされれると呼び出される
     */
    public void kigouButtonClicked(JButton button) {
        this.kigouButtonClicked(button.getText());
    }

    /**
     * 記号選択ボタンがクリックされれると呼び出される
     */
    public void kigouButtonClicked(String selected) {
        SelectedKigou = selected;
        defualtKigou = selected;
        this.refleshKigouTable();
    }

    /**
     * 画像内のポイントがクリックされると呼ばれる
     */
    public void ImageClicked(Point selectedLocation) {
        System.out.printf("(x,y) = (%d,%d)\n", selectedLocation.x, selectedLocation.y);
        //ウインドウ外を選んだ場合の処理
        if (selectedLocation.y < 0) {
            return;
        }
        if (selectedLocation.y > 6) {
            return;
        }
        if (selectedLocation.x < 0) {
            return;
        }
        if (selectedLocation.x > 6) {
            return;
        }

        String[] Column = new String[4];
        //位置
        StringBuilder LocationString = new StringBuilder();
        LocationString.append("(");
        LocationString.append(selectedLocation.x - 3);
        LocationString.append(",");
        LocationString.append(selectedLocation.y - 3);
        LocationString.append(")");
        Point point = new Point(selectedLocation.x - 3, selectedLocation.y - 3);
        Column[0] = LocationString.toString();
        //体裁
        Column[1] = this.penName.get(this.selectedPenID);
        //記号
        Column[2] = this.SelectedKigou;
        Column[3] = "";

        this.addOkototenDataToTable(Column, point);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel3 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jCheckBox3 = new javax.swing.JCheckBox();
        jCheckBox4 = new javax.swing.JCheckBox();
        jCheckBox5 = new javax.swing.JCheckBox();
        jCheckBox6 = new javax.swing.JCheckBox();
        jCheckBox7 = new javax.swing.JCheckBox();
        jTextField1 = new javax.swing.JTextField();
        jCheckBox9 = new javax.swing.JCheckBox();
        jCheckBox8 = new javax.swing.JCheckBox();
        jPanel5 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        jPanel8 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                formKeyPressed(evt);
            }
            public void keyTyped(java.awt.event.KeyEvent evt) {
                formKeyTyped(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "位置", "体裁", "記号", "削除"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Object.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTable1);

        jLabel3.setText("jLabel3");
        jLabel3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel3MouseClicked(evt);
            }
        });

        jLabel5.setText("語順点");

        jCheckBox1.setText("一");
        jCheckBox1.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox1ItemStateChanged(evt);
            }
        });

        jCheckBox2.setText("二");
        jCheckBox2.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox2ItemStateChanged(evt);
            }
        });

        jCheckBox3.setText("レ");
        jCheckBox3.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox3ItemStateChanged(evt);
            }
        });
        jCheckBox3.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jCheckBox3StateChanged(evt);
            }
        });
        jCheckBox3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox3ActionPerformed(evt);
            }
        });
        jCheckBox3.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
            public void propertyChange(java.beans.PropertyChangeEvent evt) {
                jCheckBox3PropertyChange(evt);
            }
        });

        jCheckBox4.setText("三");
        jCheckBox4.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox4ItemStateChanged(evt);
            }
        });

        jCheckBox5.setText("上");
        jCheckBox5.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox5ItemStateChanged(evt);
            }
        });

        jCheckBox6.setText("中");
        jCheckBox6.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox6ItemStateChanged(evt);
            }
        });

        jCheckBox7.setText("下");
        jCheckBox7.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox7ItemStateChanged(evt);
            }
        });

        jTextField1.setEditable(false);
        jTextField1.setText("甲乙丙");
        jTextField1.setFocusable(false);

        jCheckBox9.setText("その他");
        jCheckBox9.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox9ItemStateChanged(evt);
            }
        });

        jCheckBox8.setText("(一レ)");
        jCheckBox8.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                jCheckBox8ItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jCheckBox3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jCheckBox2)
                            .addComponent(jCheckBox1)
                            .addComponent(jCheckBox4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCheckBox6)
                            .addComponent(jCheckBox5)
                            .addComponent(jCheckBox7))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextField1)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jCheckBox9)
                                    .addComponent(jCheckBox8))
                                .addGap(0, 11, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jLabel5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBox1)
                    .addComponent(jCheckBox3)
                    .addComponent(jCheckBox5)
                    .addComponent(jCheckBox9))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBox2)
                    .addComponent(jCheckBox6)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jCheckBox4)
                    .addComponent(jCheckBox7)
                    .addComponent(jCheckBox8))
                .addGap(0, 9, Short.MAX_VALUE))
        );

        jPanel1.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                jPanel1KeyTyped(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 294, Short.MAX_VALUE)
        );

        jButton3.setText("前の文字");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("次の文字");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jLabel6.setBackground(new java.awt.Color(204, 255, 204));
        jLabel6.setFont(new java.awt.Font("MS UI Gothic", 0, 18)); // NOI18N
        jLabel6.setText("jLabel6");
        jLabel6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel6MouseClicked(evt);
            }
        });

        jLabel7.setFont(new java.awt.Font("MS UI Gothic", 0, 18)); // NOI18N
        jLabel7.setText("jLabel7");
        jLabel7.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jLabel7MouseClicked(evt);
            }
        });

        jButton1.setText("その他の位置の仮名を入力");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel9Layout.createSequentialGroup()
                .addContainerGap(47, Short.MAX_VALUE)
                .addComponent(jButton1)
                .addGap(45, 45, 45))
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jButton3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton4)
                        .addContainerGap())))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton4)
                    .addComponent(jButton3))
                .addContainerGap())
        );

        jLabel2.setText("点の形状");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 97, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jLabel2)
                .addGap(0, 0, Short.MAX_VALUE))
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jButton5.setText("音合符");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });

        jButton6.setText("訓合符");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });

        jLabel4.setText("特殊文字");

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addGroup(jPanel7Layout.createSequentialGroup()
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton6)))
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel7Layout.createSequentialGroup()
                .addComponent(jLabel4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton5)
                    .addComponent(jButton6))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jButton2.setText("体裁を追加");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 44, Short.MAX_VALUE)
        );

        jLabel1.setText("点の体裁");

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addGap(0, 0, Short.MAX_VALUE))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel8Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel8.setText("メモ");

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane2.setViewportView(jTextArea1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jPanel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jPanel4, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 307, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel8)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jScrollPane2)
                                .addContainerGap())))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 264, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel3)
                .addGap(5, 5, 5)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jPanel7, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel8)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(11, 11, 11))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void setAllData(){
        this.baseForm.setDataAt(this.openStringIndex, this.okotoTenData);
        this.baseForm.setGojunDataAt(this.openStringIndex, this.gojuntenData);
        this.baseForm.setCommentAt(this.openStringIndex, this.jTextArea1.getText());
    }
    
    /**
     * 次の文字
     */
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        //結果を保存して
        this.setAllData();
        //文字を送って
        this.baseForm.nextString();
        //次の文字に行く
        this.ChangeForcus();
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * 前の文字
     */
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        //結果を保存して
        this.setAllData();
        //文字を送って
        this.baseForm.prevString();
        //次の文字に行く
        this.ChangeForcus();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jLabel3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel3MouseClicked
        if (evt.getButton() == MouseEvent.BUTTON1 || evt.getButton() == MouseEvent.BUTTON2) {
            Toolkit kit = Toolkit.getDefaultToolkit();
            java.awt.datatransfer.Clipboard clip = kit.getSystemClipboard();

            StringBuilder sbuf = new StringBuilder();
            sbuf.append(this.baseForm.getCurrentLineTitle());
            sbuf.append("\t");
            sbuf.append(this.openStringIndex.y);
            sbuf.append("\t");
            sbuf.append(this.baseForm.getSelectedString());

            StringSelection ss = new StringSelection(sbuf.toString());
            clip.setContents(ss, ss);
            JOptionPane.showMessageDialog(this, "巻・行・丁をコピーしました", "行番号コピー", JOptionPane.INFORMATION_MESSAGE);
        } else {
            this.formMouseClicked(evt);
        }
    }//GEN-LAST:event_jLabel3MouseClicked

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        //がっぷの特殊入力（音号）
        String[] Column = new String[4];
        //位置
        StringBuilder LocationString = new StringBuilder();
        LocationString.append("(0,3)");
        Point point = new Point(0, 3);
        Column[0] = LocationString.toString();
        //体裁
        Column[1] = "墨";
        //記号
        Column[2] = "｜";
        Column[3] = "";

        this.addOkototenDataToTable(Column, point);
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        //がっぷの特殊入力（訓号）
        String[] Column = new String[4];
        //位置
        StringBuilder LocationString = new StringBuilder();
        LocationString.append("(-3,3)");
        Point point = new Point(-3, 3);
        Column[0] = LocationString.toString();
        //体裁
        Column[1] = "墨";
        //記号
        Column[2] = "｜";
        Column[3] = "";

        this.addOkototenDataToTable(Column, point);


    }//GEN-LAST:event_jButton6ActionPerformed

    private void formKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyTyped
        System.out.println(evt);// TODO add your handling code here:
    }//GEN-LAST:event_formKeyTyped

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        if (evt.getButton() == 4) {
            this.jButton3.doClick();
        } else if (evt.getButton() == 5) {
            this.jButton4.doClick();
        }
    }//GEN-LAST:event_formMouseClicked

    private void formKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyPressed
        System.out.println(evt);
    }//GEN-LAST:event_formKeyPressed

    private void jPanel1KeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_jPanel1KeyTyped
        System.out.println(evt);
    }//GEN-LAST:event_jPanel1KeyTyped

    private void jLabel6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel6MouseClicked
        String base = "";
        KanaElement hit = null;
        ArrayList<KanaElement> list = this.baseForm.getKanaDataAt(this.openStringIndex);
        if(list != null){
            for(KanaElement elem:list){
                if(elem.position == KanaInformation.PositonRight){
                    base = elem.text;
                    hit = elem;
                }
            }
        } else {
            list = new ArrayList<KanaElement>();
        }
        String inputText = JOptionPane.showInputDialog(this, base,"文字右側の仮名を入力してください",JOptionPane.QUESTION_MESSAGE);
        if (inputText != null && !inputText.equals("")) {
            KanaInformation kanadata = new KanaInformation(inputText);
            kanadata.setPositon(KanaInformation.PositonRight);
            kanadata.setColorType(this.penName.get(this.selectedPenID));
            if(hit!=null){
                list.remove(hit);
            }
            list.add(kanadata.toKanaElement());
            this.baseForm.setKanaDataAt(this.openStringIndex,list);
            this.setRightText(inputText,this.penColor.get(this.selectedPenID));
        }
    }//GEN-LAST:event_jLabel6MouseClicked

    private void jLabel7MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel7MouseClicked
        String base = "";
        KanaElement hit = null;
        ArrayList<KanaElement> list = this.baseForm.getKanaDataAt(this.openStringIndex);
        if(list != null){
            for(KanaElement elem:list){
                if(elem.position == KanaInformation.PositonLeft){
                    base = elem.text;
                    hit = elem;
                }
            }
        } else {
            list = new ArrayList<KanaElement>();
        }
        String inputText = JOptionPane.showInputDialog(this, base,"文字左側の仮名を入力してください",JOptionPane.QUESTION_MESSAGE);
        if (inputText != null && !inputText.equals("")) {
            KanaInformation kanadata = new KanaInformation(inputText);
            kanadata.setPositon(KanaInformation.PositonLeft);
            kanadata.setColorType(this.penName.get(this.selectedPenID));
            if(hit!=null){
                list.remove(hit);
            }
            list.add(kanadata.toKanaElement());
            this.baseForm.setKanaDataAt(this.openStringIndex,list);
            this.setLeftText(inputText,this.penColor.get(this.selectedPenID));
        }
    }//GEN-LAST:event_jLabel7MouseClicked

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        KanaInfomationView dialog = new KanaInfomationView(this.baseForm, this.openStringIndex);
        dialog.setVisible(true);
        this.loadKanaData();
    }//GEN-LAST:event_jButton1ActionPerformed

    
    
    private void jCheckBox3PropertyChange(java.beans.PropertyChangeEvent evt) {//GEN-FIRST:event_jCheckBox3PropertyChange
    }//GEN-LAST:event_jCheckBox3PropertyChange

    private void jCheckBox3StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jCheckBox3StateChanged
    }//GEN-LAST:event_jCheckBox3StateChanged

    private void jCheckBox3ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox3ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox3.getText(), this.jCheckBox3);
    }//GEN-LAST:event_jCheckBox3ItemStateChanged

    private void jCheckBox1ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox1ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox1.getText(), this.jCheckBox1);
    }//GEN-LAST:event_jCheckBox1ItemStateChanged

    private void jCheckBox2ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox2ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox2.getText(), this.jCheckBox2);
    }//GEN-LAST:event_jCheckBox2ItemStateChanged

    private void jCheckBox4ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox4ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox4.getText(), this.jCheckBox4);
    }//GEN-LAST:event_jCheckBox4ItemStateChanged

    private void jCheckBox5ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox5ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox5.getText(), this.jCheckBox5);
    }//GEN-LAST:event_jCheckBox5ItemStateChanged

    private void jCheckBox6ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox6ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox6.getText(), this.jCheckBox6);
    }//GEN-LAST:event_jCheckBox6ItemStateChanged

    private void jCheckBox7ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox7ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox7.getText(), this.jCheckBox7);
    }//GEN-LAST:event_jCheckBox7ItemStateChanged

    private void jCheckBox9ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox9ItemStateChanged
        if(checkboxloading) return;
        String[] Column = new String[4];
        //位置
        Column[0] = "語順点";
        //体裁
        Column[1] = this.penName.get(this.selectedPenID);
        Column[3] = "";
        if(this.jCheckBox9.isSelected()){
            String mark = JOptionPane.showInputDialog("語順点の形状を入力してください");
            this.jTextField1.setText(mark);
            //記号
            Column[2] = mark;
            this.addGojunDataToTable(Column);
        } else {
            Column[2] = this.jTextField1.getText();
            this.removeGojunDataFromTable(Column);
        }
    }//GEN-LAST:event_jCheckBox9ItemStateChanged

    private void jCheckBox8ItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_jCheckBox8ItemStateChanged
        this.gojunCheckBoxChanged(this.jCheckBox8.getText(), this.jCheckBox8);
    }//GEN-LAST:event_jCheckBox8ItemStateChanged

    private void jCheckBox3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCheckBox3ActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCheckBox3ActionPerformed

    boolean checkboxloading = false;
    private void gojunCheckBoxChanged(String mark,JCheckBox cbox){
        if(checkboxloading) return;
        String[] Column = new String[4];
        //位置
        Column[0] = "語順点";
        //体裁
        Column[1] = this.penName.get(this.selectedPenID);
        //記号
        Column[2] = mark;
        Column[3] = "";
        if (cbox.isSelected()) {
            this.addGojunDataToTable(Column);
        } else {
            this.removeGojunDataFromTable(Column);
        } 
    }
    
    /**
     * ウインドウが閉じるとき
     */
    private void windowClosing() {
        int res = JOptionPane.showConfirmDialog(this, "結果を保存しますか？", "保存の確認", JOptionPane.YES_NO_OPTION);
        if (res == JOptionPane.YES_OPTION) {
            this.setAllData();
            this.baseForm.dialogClosedWithSave();
        }
    }

    /**
     * 文字を切り替える
     */
    private void ChangeForcus() {
        this.baseForm.openNewDialog(this.getBounds());
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JCheckBox jCheckBox3;
    private javax.swing.JCheckBox jCheckBox4;
    private javax.swing.JCheckBox jCheckBox5;
    private javax.swing.JCheckBox jCheckBox6;
    private javax.swing.JCheckBox jCheckBox7;
    private javax.swing.JCheckBox jCheckBox8;
    private javax.swing.JCheckBox jCheckBox9;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextField jTextField1;
    // End of variables declaration//GEN-END:variables

}
