/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package okototentest.gui;

import java.awt.GridLayout;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import okototentest.GojuntenElement;
import okototentest.KanaElement;
import okototentest.KanaInformation;
import okototentest.OkotoPlace;
import okototentest.OkototenElement;
import okototentest.OkototenTextJSON;
import okototentest.TaggedTextParser;

/**
 *
 * @author t-koji
 */
public class OkotoInputForm extends javax.swing.JFrame {
    // 基本情報
    private static String programTitle = "移点支援システム　プロトタイプ版";
    public static final int cellWidth = 45;
    
    
    //元のテキストファイル
    private File OpendTextFile;
    //編集中のJSONファイル
    private File OpendFile;
    private MojiTablePanel tablePanel;

    // 保存用の情報
    private OkototenTextJSON okototenTextData;
    //private HashMap<Point,ArrayList<String[]>> metaData;
    //private HashMap<Point,String> mojiData;

    //ファイル読み込み用の一時データ
//    private ArrayList<String> indexNames;
//    private ArrayList<String> inputText;
    
    //GUIの現在状態 保存用
    private int selectedRow;
    private int selectedCol;
    
    private TableCellRendererFillColors myCellRenderer = new TableCellRendererFillColors();
    
    /**
     * Creates new form OkotoInputForm
     */
    public OkotoInputForm() {
        initComponents();
        this.setTitle(programTitle);
        this.jPanel1.setLayout(new GridLayout(1,1));
        this.jPanel1.add(new JLabel("ファイルを開いてください"));
        
        this.okototenTextData = new OkototenTextJSON();
        this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        this.addWindowListener(new WindowAdapter(){
            @Override
            public void windowClosing(WindowEvent e){
                OkotoInputForm.this.windowClosing();
            }
        });
    }
    

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem4 = new javax.swing.JMenuItem();
        jMenuItem5 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButton2.setText("JSONを開く");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("上書き保存");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jButton4.setText("文字コードを選択して開く");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "UTF-8", "UTF-16", "Shift-JIS", "UTF-16LE", "UTF-16BE", " " }));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 307, Short.MAX_VALUE)
        );

        jMenu1.setText("Open");

        jMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem1.setText("テキストファイルを開く");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem2.setText("文字コードを指定して開く");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem2);

        jMenuItem3.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem3.setText("JSONファイルを開く");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem3);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Save");

        jMenuItem4.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.SHIFT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem4.setText("名前を付けて保存");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem4);

        jMenuItem5.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem5.setText("上書き保存");
        jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem5ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem5);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton3)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton4)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton2)
                    .addComponent(jButton3))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    //GUIイベント
    /** ウインドウが閉じるとき */
    private void windowClosing(){
        int res = JOptionPane.showConfirmDialog(this, "結果を保存しますか？", "保存の確認", JOptionPane.YES_NO_CANCEL_OPTION);
        if(res == JOptionPane.YES_OPTION){
            this.writeFile(false,false);
            System.exit(0);
        } else if(res == JOptionPane.NO_OPTION){
            System.exit(0);
        }
    }

    private void openJSONFileAction(java.awt.event.ActionEvent evt){
        JFileChooser chooser = new JFileChooser();
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            this.OpendFile = chooser.getSelectedFile();
            try {
                int row = this.readJSONFile(this.OpendFile, "UTF-8");
                this.openData(row);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this, "選択したファイルが開けませんでした。", "FileOpenError", JOptionPane.ERROR_MESSAGE);
            }
        }        
    }
    
    /** XMLを開くボタン */
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.openJSONFileAction(evt);
    }//GEN-LAST:event_jButton2ActionPerformed

    /** 上書き保存ボタン */
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        this.writeFile(false,true);
    }//GEN-LAST:event_jButton3ActionPerformed

    /** 文字コードを指定してファイルを開くボタン */
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        JFileChooser chooser = new JFileChooser();
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            this.OpendTextFile = chooser.getSelectedFile();
            this.OpendFile = null;
            try {
                String encode = (String)this.jComboBox1.getSelectedItem();
                int row = this.readTaggedTextFile(this.OpendTextFile, encode);
                this.openData(row);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this, "選択したファイルが開けませんでした。", "FileOpenError", JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_jButton4ActionPerformed

    /** ファイルを開くメニュー */
    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        //　ファイルを開くメニュー
        JFileChooser chooser = new JFileChooser();
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            this.OpendTextFile = chooser.getSelectedFile();
            this.OpendFile = null;
            try {
                int row = this.readTaggedTextFile(this.OpendTextFile, "UTF-8");
                this.openData(row);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this, "選択したファイルが開けませんでした。", "FileOpenError", JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    /** 文字コードを指定してファイルを開くメニュー */
    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        // 文字コードを指定してファイルを開く　メニュー
        JFileChooser chooser = new JFileChooser();
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            this.OpendTextFile = chooser.getSelectedFile();
            this.OpendFile = null;
            try {
                CodeSelecter cs = new CodeSelecter(this,true);
                cs.setVisible(true);
                String encode = cs.getSelectedEncode();
                int row = this.readTaggedTextFile(this.OpendTextFile,encode);
                this.openData(row);
            } catch (IOException ex) {
                JOptionPane.showMessageDialog(this, "選択したファイルが開けませんでした。", "FileOpenError", JOptionPane.ERROR_MESSAGE);
            }
        }
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    /** JSONファイルを開くメニュー */
    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
        this.openJSONFileAction(evt);
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    /** 名前を付けて保存メニュー */
    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        // 名前を付けて保存メニュー
        this.writeFile(true,false);
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    /** 上書き保存メニュー */
    private void jMenuItem5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem5ActionPerformed
        this.writeFile(false,true);
    }//GEN-LAST:event_jMenuItem5ActionPerformed

    
    //ユーザーイベント関係
   /** セルをクリックしたときに呼び出される */
    public void cellSelected(ListMojiPanel mojipanel,MouseEvent e) {
        int selectedCellCount = this.tablePanel.getSelectedCount();
        if (selectedCellCount == 1) {
            if(e.getButton()==MouseEvent.BUTTON1){
                this.openNewDialog(null);
            } else if(e.getButton()==MouseEvent.BUTTON3){
                OkotoPlace place = mojipanel.getPlace();
                ArrayList<GojuntenElement> list = new ArrayList<GojuntenElement>();
                if(this.okototenTextData.getGojuntenDataSet().containsKey(place)){
                    list.addAll(this.okototenTextData.getGojuntenDataSet().get(place));
                }
                if(list.isEmpty()){
                    GojuntenElement elem = new GojuntenElement();
                    elem.mark = "レ";
                    elem.style = "墨";
                    list.add(elem);
                    this.okototenTextData.setGojunTenElements(place, list);
                    this.tablePanel.setGojunMark(place,list);
                    mojipanel.validate();
                    this.repaint();
                } else if(list.size() == 1) {
                    GojuntenElement elem = list.get(0);
                    String[] marks = {"レ","一","二","上","下","レ"};
                    for(int i=0;i<marks.length-1;i++){
                        if(elem.mark.equals(marks[i])){
                            elem.mark = marks[i+1];
                            break;
                        }
                    }
                    list.clear();
                    list.add(elem);
                    this.okototenTextData.setGojunTenElements(place, list);
                    this.tablePanel.setGojunMark(place,list);
                    mojipanel.validate();
                    this.repaint();
                }
            }
        } else if (selectedCellCount > 1) {
            KanaInputDialog dialog = new KanaInputDialog(this, true);
            dialog.setVisible(true);
            KanaInformation kanadata = dialog.getKanaInfo();
            KanaElement elem = kanadata.toKanaElement();
            elem.targetLength = selectedCellCount;

            ArrayList<OkotoPlace> plist = new ArrayList<OkotoPlace>();
            for(ListMojiPanel panel : this.tablePanel.getSelectedPanel()){
                plist.add(panel.getPlace());
            }
            Collections.sort(plist,new Comparator<OkotoPlace>(){
                @Override
                public int compare(OkotoPlace o1, OkotoPlace o2) {
                    if(o1.x == o2.x){
                        return Integer.compare(o1.y,o2.y);
                    } else {
                        return Integer.compare(o1.x, o2.x);
                    }
                }
            });
            OkotoPlace place = plist.get(0);
            ArrayList<KanaElement> list = this.getKanaDataAt(place);
            list.add(elem);
            this.setKanaDataAt(place, list);
            this.setKanaTipsAndColor(place,elem.targetLength,true,elem.text);
        }
    }
    
    
    private Thread dialogRunningThread;
    private OkotoInputDialog opendDialog;
    /** 次の文字などが押されて新しいダイアログを開く場合の処理 */
    public void openNewDialog(final Rectangle bounds) {
        this.dialogRunningThread = new Thread(){
            public void run() {
                OkotoInputForm.this.openNewDialogFromThread(bounds);
            }
        };
        this.dialogRunningThread.start();
    }
    
    public void openNewDialogFromThread(Rectangle bounds){
        if(this.opendDialog != null &&this.opendDialog.isVisible()){
            this.opendDialog.setVisible(false);
            this.opendDialog.dispose();
        }
        this.opendDialog = new OkotoInputDialog(this,true);
        if(bounds != null){
            this.opendDialog.setBounds(bounds);
        }
        this.opendDialog.setVisible(true);
    }
    
    /** ダイアログの次の文字ボタンが押されたときの処理 */
    public void nextString(){
        //値を追加していれば色を塗る
        OkotoPlace place = this.getSelectedIndex();
        if(this.okototenTextData.hasOkotoElement(place)){
            this.tablePanel.setFillwithOkoto(place,true);
        } else {
            this.tablePanel.setFillwithOkoto(place,false);
        }
        if(this.okototenTextData.hasGojunElement(place)){
            ArrayList<GojuntenElement> elems = this.okototenTextData.getGojuntenDataSet().get(place);
            this.tablePanel.setGojunMark(place,elems);
        }
        
        int index = this.okototenTextData.getMojiKeyset().indexOf(place);
        index++;
        if(index >= this.okototenTextData.getMojiKeyset().size()){
            JOptionPane.showMessageDialog(this, "これで最後です。", "最後の文字", JOptionPane.ERROR_MESSAGE);
            index--;
        }
        OkotoPlace newplace = this.okototenTextData.getMojiKeyset().get(index);
        this.tablePanel.setSelectedPanel(newplace);
        this.autoSave();
    }
    
    public void dialogClosedWithSave(){
        //値を追加していれば色を塗る
        OkotoPlace place = this.getSelectedIndex();
        if(this.okototenTextData.hasOkotoElement(place)){
            this.tablePanel.setFillwithOkoto(place,true);
        } else {
            this.tablePanel.setFillwithOkoto(place,false);
        }
        if(this.okototenTextData.hasGojunElement(place)){
            ArrayList<GojuntenElement> elems = this.okototenTextData.getGojuntenDataSet().get(place);
            this.tablePanel.setGojunMark(place,elems);
        }
       
        this.autoSave();
    }
    
    /** ダイアログの前の文字ボタンが押されたときの処理 */
    public void prevString(){
        //値を追加していれば色を塗る
        OkotoPlace place = this.getSelectedIndex();
        if(this.okototenTextData.hasOkotoElement(place)){
            this.tablePanel.setFillwithOkoto(place,true);
        } else {
            this.tablePanel.setFillwithOkoto(place,false);
        }
        if(this.okototenTextData.hasGojunElement(place)){
            ArrayList<GojuntenElement> elems = this.okototenTextData.getGojuntenDataSet().get(place);
            this.tablePanel.setGojunMark(place,elems);
        }
        
        int index = this.okototenTextData.getMojiKeyset().indexOf(place);
        index--;
        if(index < 0){
            JOptionPane.showMessageDialog(this, "これが最初です。", "最初の文字", JOptionPane.ERROR_MESSAGE);
            index++;
        }
        OkotoPlace newplace = this.okototenTextData.getMojiKeyset().get(index);
        this.tablePanel.setSelectedPanel(newplace);
        this.autoSave();
    }


    /** 選択中の文字が何行目何文字目かを返す(1から始まる。row,colmunではないので注意) */
    public OkotoPlace getSelectedIndex(){
        int selectedCellCount = this.tablePanel.getSelectedCount();
        if (selectedCellCount == 1) {
            OkotoPlace place = this.tablePanel.getSelectedPanel().get(0).getPlace();
            return place;
        } else if (selectedCellCount > 1) {
            //OkotoPlace place = this.tablePanel.getSelectedPanel().get(selectedCellCount-1).getPlace();
            return null;
        }
        return null;
    }

    /** 現在選択されている場所の文字を取り出す */
    public String getSelectedString(){
        int selectedCellCount = this.tablePanel.getSelectedCount();
        if (selectedCellCount == 1) {
            OkotoPlace place = this.tablePanel.getSelectedPanel().get(0).getPlace();
            return this.okototenTextData.getMojiSet().get(place);
        } else if (selectedCellCount > 1) {
            OkotoPlace place = this.tablePanel.getSelectedPanel().get(selectedCellCount-1).getPlace();
            return "";
        }
        return "";
    }
    
    
    //GUIへの入出力
    /** データの取出し*/
    public ArrayList<OkototenElement> getDataAt(OkotoPlace p){
        if(this.okototenTextData.getDataSet().containsKey(p)){
            return this.okototenTextData.getDataSet().get(p);
        } else {
            return null;
        }
    }
    //位置の取り出し
    public ArrayList<OkotoPlace> getDataIndex(){
        return this.okototenTextData.getMojiKeyset();
    }
   
    //GUIへの入出力
    /** データの取出し*/
    public ArrayList<GojuntenElement> getGojunDataAt(OkotoPlace p){
        if(this.okototenTextData.getGojuntenDataSet().containsKey(p)){
            return this.okototenTextData.getGojuntenDataSet().get(p);
        } else {
            return null;
        }
    }    
    /** データの取出し*/
    public ArrayList<KanaElement> getKanaDataAt(OkotoPlace p){
        if(this.okototenTextData.getKanaDataSet().containsKey(p)){
            return this.okototenTextData.getKanaDataSet().get(p);
        } else {
            return null;
        }
    }
    public String getCommentAt(OkotoPlace p){
        if(this.okototenTextData.hasComment(p)){
            return this.okototenTextData.getCommentDataSet().get(p);
        } else {
            return "";
        }
    }
    
    /** データの書き込み*/
    public void setDataAt(OkotoPlace p,ArrayList<OkototenElement> data){
        this.okototenTextData.getDataSet().put(p, data);
    }
    /** コメントの記録 */
    public void setCommentAt(OkotoPlace p,String memo){
        this.okototenTextData.getCommentDataSet().put(p, memo);
    }
    /** 語順点データの書き込み */
    public void setGojunDataAt(OkotoPlace openStringIndex, ArrayList<GojuntenElement> gojuntenData) {
        this.okototenTextData.getGojuntenDataSet().put(openStringIndex, gojuntenData);
    }
    /** 語順点データの書き込み */
    public void setKanaDataAt(OkotoPlace openStringIndex, ArrayList<KanaElement> kanaData) {
        this.okototenTextData.getKanaDataSet().put(openStringIndex, kanaData);
    }
    
    public String getCurrentLineTitle(){
        ArrayList<String> namelist = this.okototenTextData.getIndexNames();
        int index  = this.getSelectedIndex().getLineNumber()-1;
        return namelist.get(index);
    }

    
    //ファイル入出力関係
    /** タグを認識して開く読み込み機能 読み込み後、最大文字長を返す*/
    private int readTaggedTextFile(File inputFile,String encode) throws UnsupportedEncodingException, IOException{
        this.okototenTextData = new OkototenTextJSON(new TaggedTextParser(),inputFile,encode);
        int maxrow = this.okototenTextData.getMaxRowCount();
        
        return maxrow;
    }    
    /** JSONファイルを開く読み込み機能 読み込み後、最大文字長を返す*/
    private int readJSONFile(File inputFile,String encode) throws UnsupportedEncodingException, IOException{
        this.okototenTextData = new OkototenTextJSON();
        this.okototenTextData.openFile(inputFile, encode);
        int maxrow = this.okototenTextData.getMaxRowCount();
        
        return maxrow;
    }    
    
    /**ファイルを読み込む*/
    private void openData(int Maxrow) throws IOException {
        //データからクリック可能なパネルを作る
        this.tablePanel = new MojiTablePanel(this.okototenTextData);
        this.tablePanel.setFrame(this);
        JScrollPane scp = new JScrollPane(this.tablePanel, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
        this.jPanel1.removeAll();
        this.jPanel1.add(scp);
        
        this.validate();
        this.repaint();      
        //右端へスクロール
        scp.getHorizontalScrollBar().setValue(scp.getHorizontalScrollBar().getMaximum());
//        Rectangle pos = new Rectangle(mainpanel.getWidth()-1,0,mainpanel.getWidth(),1);
//        scp.getViewport().scrollRectToVisible(pos);
        
        this.validate();
        this.repaint();
    }

    public void autoSave(){
        File autoSaveFile;
        if(this.OpendFile == null){
            autoSaveFile = new File("autosave.json");
        } else {
            autoSaveFile = new File(this.OpendFile.getPath()+".autosave.json");
        }
        try {
            this.okototenTextData.saveFile(autoSaveFile, "UTF-8");
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, "自動保存に失敗しました。", "FileSaveError", JOptionPane.ERROR_MESSAGE);
        }
    }
    /** 上書き保存 */
    private void writeFile(boolean setNewName,boolean overWrite) {
        //既存ファイルが指定されていないか、新たにつける場合にはファイル名を決定
        if(this.OpendFile == null || setNewName == true){
            JFileChooser chooser = new JFileChooser();
            int returnVal = chooser.showSaveDialog(this);
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                String saveext = ".json";
                if(chooser.getSelectedFile().getName().toLowerCase().endsWith(saveext)){
                    this.OpendFile = chooser.getSelectedFile();
                } else {
                    this.OpendFile = new File(chooser.getSelectedFile().getPath()+saveext);
                }
                if(!this.OpendFile.exists()){
                    try {
                        this.OpendFile.createNewFile();
                    } catch (IOException ex) {
                        JOptionPane.showMessageDialog(this, "ファイル作成エラー。ファイルを作成できませんでした。", "FileSaveError", JOptionPane.ERROR_MESSAGE);
                    }
                }
                if(!this.OpendFile.isFile()){
                    JOptionPane.showMessageDialog(this, "対象がファイルではありません。ファイル名未指定", "FileSaveError", JOptionPane.ERROR_MESSAGE);
                    return;
                }
            } else {
                JOptionPane.showMessageDialog(this, "ファイルの保存に失敗しました。ファイル名未指定", "FileSaveError", JOptionPane.ERROR_MESSAGE);
                return;
            }
        } else if(overWrite != true){
            //既存ファイルがあった場合、上書き保存モードでなければ確認
            if(this.OpendFile.exists()){
                int ov = JOptionPane.showConfirmDialog(this, "ファイルを上書きしてもよろしいですか？","上書き確認",JOptionPane.YES_NO_OPTION);
                if(ov == JOptionPane.NO_OPTION){
                    return;
                }
            }
        }

        try {
            this.okototenTextData.saveFile(this.OpendFile, "UTF-8");
            JOptionPane.showMessageDialog(this, "ファイルの保存が完了しました。", "保存完了", JOptionPane.INFORMATION_MESSAGE);
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, "ファイルの保存に失敗しました。IOException", "FileSaveError", JOptionPane.ERROR_MESSAGE);
        }
            
        
    }
    

    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JMenuItem jMenuItem5;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables

    public void setKanaTipsAndColor(OkotoPlace place, int targetLength, boolean hasKana, String tipText) {
        ArrayList<OkotoPlace> placelist = this.getDataIndex();
        int index = placelist.indexOf(place);
        for(int i=0;i<targetLength;i++){
            OkotoPlace p = placelist.get(index+i);
            ListMojiPanel mojipanel = this.tablePanel.getPanel(p);
            mojipanel.setKanaMark(hasKana);
            if(tipText == null){
                mojipanel.setToolTipText(null);
            } else {
                mojipanel.setToolTipText("<html><span style=\"font-size: 180%;\">"+tipText+"</span></html>");
            }
            mojipanel.validate();
        }
        this.repaint();
    }




    

}
